// ***** BEGIN LICENSE BLOCK *****
// Version: MPL 1.1/GPL 2.0/LGPL 2.1
//
// The contents of this file are subject to the Mozilla Public License Version
// 1.1 (the "License"); you may not use this file except in compliance with
// the License. You may obtain a copy of the License at
// http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// The Original Code is mozilla.org code.
//
// The Initial Developer of the Original Code is
// the Mozilla Organization.
// Portions created by the Initial Developer are Copyright (C) 1998-2002
// the Initial Developer. All Rights Reserved.
//
// Contributor (s):
//   Robert Kaiser <KaiRo@KaiRo.at>
//   Nagarjuna Venna (vnagarjuna@yahoo.com)
//
// Alternatively, the contents of this file may be used under the terms of
// either the GNU General Public License Version 2 or later (the "GPL"), or
// the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
// in which case the provisions of the GPL or the LGPL are applicable instead
// of those above. If you wish to allow use of your version of this file only
// under the terms of either the GPL or the LGPL, and not to allow others to
// use your version of this file under the terms of the MPL, indicate your
// decision by deleting the provisions above and replace them with the notice
// and other provisions required by the GPL or the LGPL. If you do not delete
// the provisions above, a recipient may use your version of this file under
// the terms of any one of the MPL, the GPL or the LGPL.
//
// ***** END LICENSE BLOCK *****


// --- strings specific to that single Language Pack ---
var prettyName = "Nederlands";
var langcode   = "nl";
var regioncode = "NL";
var version    = "1.4b";
// --- end pack-specific strings ---


// this function verifies disk space in kilobytes
function verifyDiskSpace (dirPath, spaceRequired) {
	var spaceAvailable;

	// Get the available disk space on the given path
	spaceAvailable = fileGetDiskSpaceAvailable (dirPath);

	// Convert the available disk space into kilobytes
	spaceAvailable = parseInt (spaceAvailable / 1024);

	// do the verification
	if (spaceAvailable < spaceRequired) {
		logComment ("Onvoldoende schijfruimte: " + dirPath);
		logComment ("             benodigd   : " + spaceRequired + " KB");
		logComment ("             beschikbaar: " + spaceAvailable + " KB");
		return (false);
	}

	return (true);
}

// this function converts an error number to the error code
function ErrCode (errornum) {
	if (errornum == 0)  {
		errorstring = "SUCCES";
	} else if (errornum == -200)  {
		errorstring = "FOUTE_PAKKET_NAAM";
	} else if (errornum == -201) {
		errorstring = "ONVERWACHTE_FOUT";
	} else if (errornum == -202) {
		errorstring = "TOEGANG_GEWEIGERD";
	} else if (errornum == -203) {
		errorstring = "TE_VEEL_CERTIFICATEN";
	} else if (errornum == -204) {
		errorstring = "GEEN_INSTALLATIE_SCRIPT";
	} else if (errornum == -205) {
		errorstring = "GEEN_CERTIFICAAT";
	} else if (errornum == -206) {
		errorstring = "GEEN_OVEREENKOMEND_CERTIFICAAT";
	} else if (errornum == -207) {
		errorstring = "KAN_ARCHIEF_NIET_LEZEN";
	} else if (errornum == -208) {
		errorstring = "FOUTE_ARGUMENTEN";
	} else if (errornum == -209) {
		errorstring = "ILLEGAAL_RELATIEF_PAD";
	} else if (errornum == -210) {
		errorstring = "AFGEBROKEN_DOOR_GEBRUIKER";
	} else if (errornum == -211) {
		errorstring = "INSTALLATIE_NIET_GESTART";
	} else if (errornum == -212) {
		errorstring = "STILLE_MODUS_GEWEIGERD";
	} else if (errornum == -213) {
		errorstring = "NIET_ZO_EEN_COMPONENT";
	} else if (errornum == -214) {
		errorstring = "BESTAAT_NIET";
	} else if (errornum == -215) {
		errorstring = "ALLEEN_LEZEN";
	} else if (errornum == -216) {
		errorstring = "IS_MAP";
	} else if (errornum == -217) {
		errorstring = "NETWERK_BESTAND_IS_IN_GEBRUIK";
	} else if (errornum == -218) {
		errorstring = "APPLE_ENKELE_FOUT";
	} else if (errornum == -219) {
		errorstring = "ONGELDIG_PAD_FOUT";
	} else if (errornum == -220) {
		errorstring = "PATCH_SLECHTE_DIFF";
	} else if (errornum == -221) {
		errorstring = "PATCH_SLECHT_CHECKSUM_DOEL";
	} else if (errornum == -222) {
		errorstring = "PATCH_SLECHT_CHECKSUM_RESULTAAT";
	} else if (errornum == -223) {
		errorstring = "DEINSTALLATIE_MISLUKT";
	} else if (errornum == -224) {
		errorstring = "PACKKET_MAP_NIET_INGESTELD";
	} else if (errornum == -225) {
		errorstring = "EXTRACTIE_MISLUKT";
	} else if (errornum == -226) {
		errorstring = "BESTANDSNAAM_REEDS_GEBRUIKT";
	} else if (errornum == -227) {
		errorstring = "INSTALLATIE_AFGEBROKEN";
	} else if (errornum == -228) {
		errorstring = "OPHAAL_FOUT";
	} else if (errornum == -229) {
		errorstring = "SCRIPT_FOUT";
	} else if (errornum == -230) {
		errorstring = "BESTAAT_REEDS";
	} else if (errornum == -231) {
		errorstring = "IS_BESTAND";
	} else if (errornum == -232) {
		errorstring = "BRON_BESTAAT_NIET";
	} else if (errornum == -233) {
		errorstring = "BRON_IS_MAP";
	} else if (errornum == -234) {
		errorstring = "BRON_IS_BESTAND";
	} else if (errornum == -235) {
		errorstring = "ONVOLDOENDE_SCHIJFRUIMTE";
	} else if (errornum == -236) {
		errorstring = "BESTANDSNAAM_TE_LANG";
	} else if (errornum == -237) {
		errorstring = "NIET_IN_STAAT_LIB_FUNCTIE_TE_LOCALISEREN";
	} else if (errornum == -238) {
		errorstring = "NIET_IN_STAAT_LIBRARY_TE_LADEN";
	} else if (errornum == -239) {
		errorstring = "CHROME_REGISTRATIE_FOUT";
	} else if (errornum == -240) {
		errorstring = "ONGELDIGE_INSTALLATIE";
	} else if (errornum == -299) {
		errorstring = "GEHEUGENTEKORT";
	} else if (errornum == 999) {
		errorstring = "HERSTART_BENODIGD";
	} else if (errornum == -5550) {
		errorstring = "GESTALT_ONBEKENDE_FOUT";
	} else if (errornum == -5551) {
		errorstring = "GESTALT_ONGELDIG_ARGUMENT";
	} else {
		errorstring = "Fout Nr. " + errornum;
	}

	return (errorstring);
}

// this function converts an error number to a string with code and number
function ErrWithCode (errornum) {
	return (err + " (" + ErrCode (err) + ")");
}

// OS type detection - which platform?
function getPlatform () {
	var platformStr;
	var platformNode;

	if ('platform' in Install) {
		platformStr = new String (Install.platform);

		if (! platformStr.search (/^Macintosh/)) {
			platformNode = 'mac';
		} else if (! platformStr.search (/^Win/)) {
			platformNode = 'win';
		} else {
			platformNode = 'unix';
		}
	} else {
		var fOSMac  = getFolder ("Mac System");
		var fOSWin  = getFolder ("Win System");

		logComment ("fOSMac: "  + fOSMac);
		logComment ("fOSWin: "  + fOSWin);

		if (fOSMac != null) {
			platformNode = 'mac';
		} else if (fOSWin != null) {
			platformNode = 'win';
		} else {
			platformNode = 'unix';
		}
	}

	return platformNode;
}

// *** start main install routine ***

var srDest = 600;
var err;
var fProgram;
var platformNode;
var profileInstall = 0;
var alertstring;

platformNode = getPlatform ();
logComment ("taalpakket installatie: soort platform gedetecteerd als: " + platformNode);

var chromeNode   = langcode + "-" + regioncode;
var regName      = "locales/mozilla/" + chromeNode;
var chromeName   = chromeNode + ".jar";
var regionFile   = regioncode + ".jar";
var platformName = langcode + "-" + platformNode + ".jar";
var localeName   = "locale/" + chromeNode + "/";
var regionName   = "locale/" + regioncode + "/";

err = initInstall (prettyName, regName, version); 
logComment ("initInstall: " + ErrWithCode (err));

var messages = loadResources ("install.properties");

fProgram = getFolder ("Program");
logComment ("fProgram: " + fProgram);

if ((err == 0) && verifyDiskSpace (fProgram, srDest)) {
	var chromeType = LOCALE;
	var tellRestart = 0;

	// ask for global or profile install
	// don't use this dialog for now...
	//  if (confirm (messages.install_confirm)) {
	if (true) {
		wantGlobalInstall = 1;
	} else {
		wantGlobalInstall = 0;
	}

	if (wantGlobalInstall) {
		err = addDirectory ("", "chrome", fProgram, "chrome");
		logComment ("addDirectory () voor chrome kwam terug met de waarde: " + ErrWithCode (err));
	}

	if ((! wantGlobalInstall) || (err != 0)) {
		// return value 0 is SUCCESS
		logComment ("addDirectory () van " + fProgram + "mislukt!");

		// couldn't install globally, try installing to the profile
		resetError ();
		chromeType |= PROFILE_CHROME;
		profileInstall = 1;
		fProgram = getFolder ("Profile");
		logComment ("probeer naar een ander gebruikersprofiel te installeren:" + fProgram);
		err = addDirectory ("", "chrome", fProgram, "chrome");
		logComment ("addDirectory () voor profile chrome kwam terug met de waarde: " + ErrWithCode (err));
	}

	setPackageFolder (fProgram);

	// check return value: 0 is SUCCESS, 999 is REBOOT_NEEDED
	if ((err == 0) || (err == 999)) {
		var tellReboot = 0;
		if (err == 999) {
			tellReboot = 1;
			resetError ();
		}
		// register chrome
		var cf = getFolder (fProgram, "chrome/"+chromeName);
		var pf = getFolder (fProgram, "chrome/"+platformName);
		var rf = getFolder (fProgram, "chrome/"+regionFile);

		registerChrome (chromeType, cf, localeName + "p3p/");
		registerChrome (chromeType, cf, localeName + "help/");
		registerChrome (chromeType, cf, localeName + "necko/");
		registerChrome (chromeType, cf, localeName + "communicator/");
		registerChrome (chromeType, cf, localeName + "navigator/");
		registerChrome (chromeType, cf, localeName + "autoconfig/");
		//registerChrome (chromeType, cf, localeName + "chatzilla/");
		//registerChrome (chromeType, cf, localeName + "calendar/");
		registerChrome (chromeType, cf, localeName + "cookie/");
		registerChrome (chromeType, cf, localeName + "editor/");
		registerChrome (chromeType, cf, localeName + "global/");
		registerChrome (chromeType, cf, localeName + "mozldap/");
		registerChrome (chromeType, cf, localeName + "messenger-smime/");
		registerChrome (chromeType, cf, localeName + "pipnss/");
		registerChrome (chromeType, cf, localeName + "pippki/");
		//registerChrome (chromeType, cf, localeName + "venkman/");
		registerChrome (chromeType, cf, localeName + "wallet/");
		registerChrome (chromeType, cf, localeName + "messenger/");
		registerChrome (chromeType, cf, localeName + "content-packs/");
		//registerChrome (chromeType, cf, localeName + "inspector/");
		registerChrome (chromeType, rf, regionName + "navigator-region/");
		registerChrome (chromeType, rf, regionName + "editor-region/");
		registerChrome (chromeType, rf, regionName + "messenger-region/");
		registerChrome (chromeType, rf, regionName + "communicator-region/");
		registerChrome (chromeType, rf, regionName + "global-region/");
		registerChrome (chromeType, pf, localeName + "navigator-platform/");
		registerChrome (chromeType, pf, localeName + "global-platform/");
		registerChrome (chromeType, pf, localeName + "communicator-platform/");
		if (platformNode == 'win') {
			registerChrome (chromeType, pf, localeName + "messenger-mapi/");
		}

		err = performInstall (); 
		logComment ("performInstall () kwam terug met de waarde: " + ErrWithCode (err));
		if (err == 999) {
			tellReboot = 1;
			resetError ();
			err = 0;
		}
		if (err == 0) {
			if (profileInstall == 1) {
				alertstring = messages.install_successprofile;
			} else {
				alertstring = messages.install_successglobal;
			}
			if (tellReboot == 1) {
				alertstring = alertstring + "\n\n" + messages.tell_reboot;
				logComment ("HERSTART_BENODIGD (999): gebruiker aan het waarschuwen dat hij zijn systeem moet herstarten.");
				cancelInstall (REBOOT_NEEDED);
			} else {
				if (tellRestart == 1) {
					alertstring = alertstring + "\n\n" + messages.tell_restart;
					logComment ("we gebruikten DELAYED_CHROME: gebruiker aan het waarschuwen dat hij Mozilla herstarten.");
				}
			}
			alertstring = alertstring + "\n\n" + messages.howto_switch;
		} else {
			alertstring = messages.install_failed + " " + ErrWithCode (err) + ".";
			cancelInstall (err);
		}
	} else {
		cancelInstall (err);
		logComment ("cancelInstall vanwege fout: " + ErrWithCode (err));
		alertstring = messages.install_cancel + " " + ErrWithCode (err) + ".";
		if ((err == -202) || (err == -215)) {
			// -202 is ACCESS_DENIED, -215 is READ_ONLY
			alertstring = alertstring + "\n\n" + messages.need_write_perm;
			if (err == -202) {
				logComment ("TOEGANG_GEWEIGERD (-202): gebruiker aan het waarschuwen dat hij waarschijnlijk geen schrijftoegang tot chrome heeft.");
			} else {
				logComment ("ALEEN_LEZEN (-215): gebruiker aan het waarschuwen dat hij waarschijnlijk geen schrijftoegang tot chrome heeft.");
			}
		}
	}
	alert (alertstring);
} else {
	if (err == 0) {
		cancelInstall (INSUFFICIENT_DISK_SPACE);
	} else {
		cancelInstall (err);
	}
}
